;
        TITLE   VGAANSI
;
        PAGE    198,81
;
; ANSI.SYS for VGA adapters, Version 1.00
; Copyright (C) 1991, David Ryan Sheldon
; 2-10-91
;
;-----------------------------------------------
;
;equates
;
BPT     EQU     BYTE PTR      ;abbrieviations
WPT     EQU     WORD PTR
DPT     EQU     DWORD PTR
SHO     EQU     SHORT
OFS     EQU     OFFSET
;
;-----------------------------------------------
;
;far segment data definitions
;
_ABSO   SEGMENT AT 0
;
        ORG     20h
AINT08  LABEL   DWORD         ;INT 08h vector
;
        ORG     24h
AINT09  LABEL   DWORD         ;INT 09h vector
;
        ORG     40h
AINT10  LABEL   DWORD         ;INT 10h vector
;
        ORG     6Ch
AINT1B  LABEL   DWORD         ;INT 1Bh vector
;
        ORG     0A4h
AINT29  LABEL   DWORD         ;INT 29h vector
;
        ORG     1C0h
AINT70  LABEL   DWORD         ;INT 70h vector
;
        ORG     44Ah
ACOLMX  DB      ?             ;maximum column
;
        ORG     450h
APPARY  LABEL   WORD          ;page/pos array
;
        ORG     462h
AVPAGE  DB      ?             ;active page
;
        ORG     484h
AROWMX  DB      ?             ;maximum row
;
_ABSO   ENDS
;
;-----------------------------------------------
;
_TEXT   SEGMENT BYTE PUBLIC 'CODE'
        ASSUME  CS:_TEXT
;
;-----------------------------------------------
;
;device header structure
;
        DD      -1            ;prev driver link
        DW      8013h         ;device attribute
        DW      STRAT         ;strategy routine
        DW      INTRP         ;interrupt routine
        DB      'CON'         ;logical device
        DB      5 DUP(20h)    ; name w/pads
;
;-----------------
;
;dispatch branch vector table
;
DSPTCH  DW      DINIT0        ;0 initialize
        DW      INTRP2        ;1 (done)
        DW      INTRP2        ;2 (done)
        DW      INTRP0        ;3 (request error)
        DW      DREAD0        ;4 read
        DW      NDDRD0        ;5 nondestrct read
        DW      INTRP2        ;6 (done)
        DW      FLUSH1        ;7 flush input
        DW      WRITE0        ;8 write
        DW      WRITE0        ;9 verify write
        DW      INTRP2        ;A (done)
        DW      INTRP2        ;B (done)
;
;-----------------
;
;ANSI escape sequence tables
;
SQCHAR  DB      'JmHfsuCB'    ;supported ANSI
        DB      'DAKnRhlp'    ; sequence chars
;
SQCQTY  EQU     $-OFS SQCHAR
;
SQPROC  DW      SQCLS0        ;J clear screen
        DW      SATTR0        ;m set attributes
        DW      SSPOS0        ;H set position
        DW      SSPOS0        ;f set position
        DW      SSAVE0        ;s save position
        DW      SRSTR0        ;u rstore position
        DW      SRGHT0        ;C cursor right
        DW      SDOWN0        ;B cursor down
        DW      SLEFT0        ;D cursor left
        DW      SQPUP0        ;A cursor up
        DW      SCEOL0        ;K clear end/line
        DW      SRQST0        ;n pos request
        DW      SRPRT0        ;R pos report
        DW      SMDEW0        ;h mode/enbl wrap
        DW      SMDDW0        ;l mode/disbl wrap
SQLAST  DW      SRKEY0        ;p reassign key
;
;-----------------
;
;ANSI video attribute tables
;
VASNUM  DB      0,1,4,5,7,8   ;supported ANSI
        DB      1Eh,1Fh,20h,21h ; video
        DB      22h,23h,24h,25h ; attribute
        DB      28h,29h,2Ah,2Bh ; values
        DB      2Ch,2Dh,2Eh,2Fh ; table
;
VASQTY  EQU     $-OFS VASNUM
;
VASOPS  DW      700h          ;00 normal attr
        DW      8FFh          ;01 high intensity
        DW      1F8h          ;04 underline
        DW      80FFh         ;05 blink
        DW      70F8h         ;07 normal reverse
        DW      88h           ;08 hidden attr
        DW      0F8h          ;1E black f.g.
        DW      4F8h          ;1F red f.g.
        DW      2F8h          ;20 green f.g.
        DW      6F8h          ;21 yellow f.g.
        DW      1F8h          ;22 blue f.g.
        DW      5F8h          ;23 magenta f.g.
        DW      3F8h          ;24 cyan f.g.
        DW      7F8h          ;25 white f.g.
        DW      8Fh           ;28 black b.g.
        DW      408Fh         ;29 red b.g.
        DW      208Fh         ;2A green b.g.
        DW      608Fh         ;2B yellow b.g.
        DW      108Fh         ;2C blue b.g.
        DW      508Fh         ;2D magenta b.g.
        DW      308Fh         ;2E cyan b.g.
VALAST  DW      708Fh         ;2F white b.g.
;
;-----------------
;
;miscelleneous data area
;
WSTATE  DW      WANRM         ;write state proc
;
PRRSTR  DB      1Bh,'['       ;ANSI position
PRRROW  LABEL   WORD          ;(row word)
        DB      '00;'         ; report string
PRRCOL  LABEL   WORD          ;(column word)
        DB      '00R',0Dh     ; w/terminator
;
;-----------------------------------------------
;
;device driver strategy routine
;
STRAT   PROC    FAR           ;open procedure
;
        MOV     CS:RHSSEG,ES  ;store req hdr seg
        MOV     CS:RHSOFS,BX  ;store req hdr ofs
        RET                   ;return to caller
;
STRAT   ENDP                  ;close procedure
;
;-----------------
;
;device driver interrupt routine
;
INTRP   PROC    FAR           ;open procedure
;
        PUSH    DI            ;save DI register
;
        DB      0BFh          ;MOV DI,immediate
RHSSEG  DW      ?             ;reqst hdr segment
;
        PUSH    ES            ;save ES register
        MOV     ES,DI         ;req hdr seg in ES
        PUSHF                 ;save flags reg
;
        DB      0BFh          ;MOV DI,immediate
RHSOFS  DW      ?             ;reqst hdr offset
;
        PUSH    AX            ;save AX register
        INC     DI            ;point to command
        INC     DI            ; code byte in DI
        PUSH    CX            ;save CX register
        MOV     AL,ES:[DI]    ;command in AL reg
        INC     DI            ;point to status
        PUSH    DS            ;save DS register
        CMP     AL,0Bh        ;request valid ?
        PUSH    SI            ;save SI register
        JA      INTRP0        ;no - error exit
;
        PUSH    CS            ;loc seg on stack
        CLD                   ;addresses ascend
        POP     DS            ;local seg in DS
        MOV     CX,ES:[DI+0Fh] ;xfer byte count
        CBW                   ;zero AH register
        SHL     AX,1          ;word table index
        XCHG    AX,SI         ;vect index in SI
        JMP WPT [SI+12h]      ;DSPTCH[SI]
;
INTRP0: MOV     AX,8103h      ;request error
        JMP SHO INTRP3        ;set status exit
;
INTRP1: MOV     AH,3          ;busy status in AH
        JMP SHO INTRP3        ;set status exit
;
INTRP2: MOV     AH,1          ;done status in AH
;
INTRP3: POP     SI            ;restore SI reg
        POP     DS            ;restore DS reg
        POP     CX            ;restore CX reg
        STOSW                 ;store status word
        POP     AX            ;restore AX reg
        POPF                  ;restore flags reg
        POP     ES            ;restore ES reg
        POP     DI            ;restore DI reg
        RET                   ;return to caller
;
INTRP   ENDP                  ;close procedure
;
;-----------------
;
;flush input buffer routine
;
FLUSH   PROC    NEAR          ;open procedure
;
        ASSUME  DS:_TEXT
;
FLUSH0: XOR     AH,AH         ;get kbd character
        INT     16h           ;BIOS keybrd call
;
FLUSH1: MOV     AH,1          ;get kbrd status
        INT     16h           ;BIOS keybrd call
        JNZ     FLUSH0        ;until bufr empty
;
        XOR     AX,AX         ;zero AX register
        MOV     KSTATE,AX     ;reset kbrd state
        JMP     INTRP2        ;empty - done exit
;
FLUSH   ENDP                  ;close procedure
;
;-----------------
;
;nondestructive read routine
;
NDDRD   PROC    NEAR          ;open procedure
;
NDDRD0:
;
        DB      0B8h          ;MOV AX,immediate
KSTATE  LABEL   WORD          ;keyboard state wd
KCHBUF  DB      0             ;kybrd char buffer
KBFCNT  DB      0             ;kybd buffer count
;
        OR      AX,AX         ;buffers empty ?
        JNZ     NDDRD3        ;no - test chr bfr
;
NDDRD1: MOV     AH,1          ;get keybrd status
        INT     16h           ;BIOS keybrd call
        JZ      INTRP1        ;none - busy exit
;
        OR      AX,AX         ;null char ?
        JZ      NDDRD6        ;yes - clear it
;
        CALL    RSRCH         ;search reasgn bfr
        JNC     NDDRD4        ;found - get byte
;
NDDRD2: MOV     ES:[DI+0Ah],AL ;store xfer char
        JMP     INTRP2        ;done status exit
;
NDDRD3: OR      AL,AL         ;char bfr empty ?
        JNZ     NDDRD2        ;no - store char
;
        XCHG    AX,CX         ;nonzero in CX reg
        MOV     SI,KBFPTR     ;yes - ptr in SI
;
NDDRD4: JCXZ    NDDRD5        ;null - clear
;
        LODSB                 ;get source byte
        JMP     NDDRD2        ;store char exit
;
NDDRD5: XCHG    AX,CX         ;get kbd character
;
NDDRD6: INT     16h           ;BIOS keybrd call
        JMP     NDDRD1        ;retry status
;
NDDRD   ENDP                  ;close procedure
;
;-----------------
;
;write/verify write routine
;
WRITE   PROC    NEAR          ;open procedure
;
        ASSUME  DS:NOTHING
;
WRITE0: JCXZ    INTRP2        ;no chars - done
;
        PUSH    BX            ;save BX register
        PUSH    DX            ;save DX register
        PUSH    CX            ;save CX register
        CALL    WINIT         ;write initialize
        POP     CX            ;restore CX reg
        LDS     SI,ES:[DI+0Bh] ;DS:SI = source
        PUSH    BP            ;save BP register
;
WRITE1: LODSB                 ;get next byte
        PUSH    CX            ;save CX register
        XOR     CX,CX         ;zero CX register
        PUSH    DS            ;save DS register
        MOV     DS,CX         ;_ABSO in DS reg
        PUSH    SI            ;save SI register
        CALL WPT CS:WSTATE    ;write character
        POP     SI            ;restore SI reg
        POP     DS            ;restore DS reg
        POP     CX            ;restore CX reg
        LOOP    WRITE1        ;count, until done
;
        POP     BP            ;restore BP reg
        POP     DX            ;restore DX reg
        POP     BX            ;restore BX reg
;
;- - - - - - - - -
;
;device read routine
;
DREAD   PROC    NEAR          ;open nested proc
;
        ASSUME  DS:_TEXT
;
DREAD0: JCXZ    INTRP2        ;no chars - done
;
        PUSH    ES            ;save ES register
        PUSH    DI            ;save DI register
        LES     DI,ES:[DI+0Bh] ;ES:DI = dest
;
DREAD1: XOR     AX,AX         ;zero AX register
        XCHG    AL,KCHBUF     ;get/clr char bufr
        OR      AL,AL         ;char bufr empty ?
        JNZ     DREAD8        ;no - store char
;
        XCHG    AL,KBFCNT     ;yes - bufr count
        OR      AL,AL         ;kybd bufr empty ?
        JNZ     DREAD6        ;yes - get bfr chr
;
DREAD2: PUSH    CX            ;no - save CX reg
;
DREAD3: INT     16h           ;BIOS keybrd call
        OR      AX,AX         ;null char ?
        JZ      DREAD3        ;yes - until not
;
        CALL    RSRCH         ;search reasgn bfr
        JC      DREAD7        ;not found - store
;
        POP     AX            ;loop count in AX
;
DREAD4: SUB     AX,CX         ;too many chars ?
        JNC     DREAD5        ;no - move all
;
        NEG     AX            ;negate result
        MOV     KBFCNT,AL     ;store buffer qty
        SUB     CX,AX         ;xfer qty in CX
        STC                   ;set exit flag
;
DREAD5: REP     MOVSB         ;move reasgn chars
        XCHG    AX,CX         ;loop count in CX
        JA      DREAD2        ;loop if not done
;
        MOV     KBFPTR,SI     ;set kybd bufr ptr
        JMP SHO DREAD9        ;done - exit
;
DREAD6: XCHG    AX,CX         ;bufr count in CX
;
        DB      0BEh          ;MOV SI,immediate
KBFPTR  DW      ?             ;keybrd buffer ptr
;
        JMP     DREAD4        ;move buffer chars
;
DREAD7: POP     CX            ;restore loop cnt
        OR      AL,AL         ;extended key ?
        JNZ     DREAD8        ;no - store char
;
        MOV     KCHBUF,AH     ;yes - save second
;
DREAD8: STOSB                 ;store character
        LOOP    DREAD1        ;count, until done
;
DREAD9: POP     DI            ;restore DI reg
        POP     ES            ;restore ES reg
        JMP     INTRP2        ;done exit
;
DREAD   ENDP                  ;close nested proc
;
;- - - - - - - - -
;
WRITE   ENDP                  ;close procedure
;
;-----------------
;
;write ANSI quote routine
;
WAQUO   PROC    NEAR          ;open procedure
;
        DB      3Ch           ;CMP AL,immediate
OQUOTE  DB      ?             ;open quote byte
;
        JZ      WAQUO0        ;match - close quo
;
        CALL    RINDX         ;get buffer index
        XOR     AH,AH         ;null in AH reg
        INC WPT CS:WAINDX     ;point to next
        JMP SHO WABRC4        ;store char/null
;
WAQUO0: MOV     AX,OFS WABRC  ;write = brace
        JMP     WANRMC        ;set write exit
;
WAQUO   ENDP                  ;close procedure
;
;-----------------
;
;write ANSI brace routine
;
WABRC   PROC    NEAR          ;open procedure
;
        ASSUME  DS:_ABSO
;
        CMP     AL,39h        ;char > ASCII 9 ?
        JA      WABRC6        ;yes - test others
;
        CMP     AL,30h        ;char < ASCII 0 ?
        JB      WABRC0        ;yes - test others
;
        CALL    RINDX         ;get buffer index
        XOR     AL,30h        ;remove ASCII bits
        XCHG    AL,CS:[SI]    ;swap source/dest
        MOV     AH,0Ah        ;multiplier in AH
        MUL     AH            ;unsigned multiply
        ADD     CS:[SI],AL    ;add to least sgnf
        MOV     AL,1          ;one parm written
        MOV     CS:PARMFL,AL  ;parm written flag
        RET                   ;return to caller
;
WABRC0: CMP     AL,22h        ;char = '"' ?
        JZ      WABRC1        ;yes - open quote
;
        CMP     AL,27h        ;char = "'" ?
        JNZ     WAESC0        ;no - set nrm wrt
;
WABRC1: MOV     CS:OQUOTE,AL  ;save match char
        MOV     AX,OFS WAQUO  ;write = quote
        MOV     CS:WSTATE,AX  ;set write state
;
WABRC2: XOR     AX,AX         ;zero AX register
        XCHG    AL,CS:PARMFL  ;get/clr parm flag
        ADD     CS:WAINDX,AX  ;adjust write indx
        MOV     AL,AH         ;zero AL register
;
WABRC3: CALL    RINDX         ;get buffer index
;
WABRC4: MOV     CS:[SI],AX    ;zero two bytes
;
WABRC5: RET                   ;return to caller
;
WABRC6: CMP     AL,3Bh        ;char = ';' ?
        JZ      WABRC2        ;yes - next parm
;
        CMP     AL,3Dh        ;char = '=' ?
        JZ      WABRC5        ;yes - ignore
;
        CMP     AL,3Fh        ;char = '?' ?
        JZ      WABRC5        ;yes - ignore
;
        MOV     CL,SQCQTY     ;no - sq qty in CX
        PUSH    DI            ;save DI register
        MOV     DI,OFS SQCHAR ;seq char list ptr
        PUSH    ES            ;save ES register
        PUSH    CS            ;loc seg on stack
        POP     ES            ;local seg in ES
        REPNZ   SCASB         ;valid sequence ?
        POP     ES            ;restore ES reg
        POP     DI            ;restore DI reg
        JNZ     WAESC0        ;no - set normal
;
        ASSUME  DS:_TEXT
;
        SHL     CX,1          ;yes - word index
        MOV     SI,OFS SQLAST ;last seq proc ptr
        SUB     SI,CX         ;point to selected
        PUSH    ES            ;save ES register
        PUSH    DS            ;_ABSO on stack
        POP     ES            ;_ABSO seg in ES
        PUSH    CS            ;loc seg on stack
        POP     DS            ;local seg in DS
;
        DB      0B8h          ;MOV AX,immediate
PARMFL  DB      0,0           ;parm written flag
;
        ADD     WAINDX,AX     ;index = parm qty
        LODSW                 ;get proc offset
        XCHG    AX,CX         ;proc in CX reg
        MOV     SI,KRINDX     ;point to 1st parm
        LODSB                 ;first parm in AL
        JMP     CX            ;execute seq proc
;
        ASSUME  DS:_ABSO
;
WABRC   ENDP                  ;close procedure
;
;-----------------
;
;write ANSI escape routine
;
WAESC   PROC    NEAR          ;open procedure
;
        CMP     AL,5Bh        ;char = '[' ?
        JNZ     WAESC0        ;no - set normal
;
        MOV     AX,OFS WABRC  ;write = brace
        MOV     CS:WSTATE,AX  ;set write state
        XOR     AX,AX         ;zero AX register
        MOV     CS:PARMFL,AL  ;clear parm flag
        MOV     CS:WAINDX,AX  ;clear parm index
        JMP     WABRC3        ;clear destination
;
WAESC0: MOV CS:WSTATE,OFS WANRM ;write = normal
;
;- - - - - - - - -
;
;write ANSI normal routine
;
WANRM   PROC    NEAR          ;open nested proc
;
        DB      0B4h          ;MOV AH,immediate
WRAPFL  DB      1             ;line wrap flag
;
        CMP     AL,1Bh        ;char <= ESC ?
        JBE     WANRM7        ;yes - may be spcl
;
WANRM0: SHR     AH,1          ;no - wrap actve ?
        JA      WANRM3        ;yes - set inactve
;
WANRM1: MOV     AH,9          ;write character
        INC     CX            ;replicate = one
        INT     10h           ;BIOS video call
        INC     DX            ;adjust column
        CMP     DL,ACOLMX     ;end of line ?
        JAE     WANRM4        ;yes - test wrap
;
WANRM2: MOV     AH,2          ;no - set crsr pos
        INT     10h           ;BIOS video call
        RET                   ;return to caller
;
WANRM3: MOV     CS:WRAPFL,AH  ;set wrap inactive
        JMP     WANRM1        ;write character
;
WANRM4: SHL     CS:WRAPFL,1   ;set wrap active
        JZ      WANRM6        ;wrap disabled
;
        MOV     DL,CH         ;zero column reg
;
WANRM5: INC     DH            ;increment row reg
        CMP     DH,AROWMX     ;end of page ?
        JBE     WANRM2        ;no - set crsr pos
;
        DEC     DH            ;yes - last row
        CALL    WCTTY         ;write char TTY
        JMP     WANRM2        ;set crsr position
;
WANRM6: DEC     DX            ;ignore column adj
        RET                   ;return to caller
;
WANRM7: JZ      WANRMB        ;ESC - set escape
;
        CMP     AL,8          ;chr = BACKSPACE ?
        JZ      WANRM9        ;yes - backspace
;
        CMP     AL,0Dh        ;char = CAR RET ?
        JZ      WANRMA        ;yes - car ret
;
        CMP     AL,7          ;char = BELL ?
        JZ      WCTTY0        ;yes - write TTY
;
        CMP     AL,0Ah        ;char = LINE FEED ?
        JNZ     WANRM0        ;no - write char
;
        SHR     AH,1          ;yes - wrap actv ?
        JBE     WANRM5        ;no - line wrap
;
        MOV     CS:WRAPFL,AH  ;yes - set inactve
;
WANRM8: RET                   ;return to caller
;
WANRM9: OR      DL,DL         ;column = 0 ?
        JZ      WANRM8        ;yes - exit
;
        DEC     DX            ;no - backspace
        JMP     WANRM2        ;set crsr position
;
WANRMA: MOV     DL,CH         ;set column = 0
        JMP     WANRM2        ;set crsr position
;
WANRMB: MOV     AX,OFS WAESC  ;write = escape
;
WANRMC: MOV     CS:WSTATE,AX  ;set write state
        RET                   ;return to caller
;
WANRM   ENDP                  ;close nested proc
;
;- - - - - - - - -
;
WAESC   ENDP                  ;close procedure
;
;-----------------
;
;write character TTY subroutine
;
WCTTY   PROC    NEAR          ;open procedure
;
WCTTY0: MOV     AH,0Eh        ;write char TTY
        PUSH    BX            ;save BX register
        AND     BL,7          ;foreground only
        INT     10h           ;BIOS video call
        POP     BX            ;restore BX reg
        RET                   ;return to caller
;
WCTTY   ENDP                  ;close procedure
;
;-----------------
;
;[x;xm set attributes
;
SATTR   PROC    NEAR          ;open procedure
;
        ASSUME  DS:_TEXT,ES:_ABSO
;
SATTR0: MOV     AX,WAINDX     ;parm count in AX
        XCHG    AX,CX         ;parm count in CX
        JCXZ    SRPRT0        ;no parms - exit
;
        DEC     SI            ;point to 1st parm
        PUSH    CS            ;loc seg on stack
        POP     ES            ;local seg in ES
        PUSH    DI            ;save DI register
;
SATTR1: LODSB                 ;get parm byte
        MOV     DI,OFS VASNUM ;point to num list
        PUSH    CX            ;save CX register
        MOV     CL,VASQTY     ;num qty in CX reg
        REPNZ   SCASB         ;valid number ?
        JNZ     SATTR2        ;no - loop exit
;
        SHL     CX,1          ;yes - word index
        PUSH    SI            ;save SI register
        MOV     SI,OFS VALAST ;last operand ptr
        SUB     SI,CX         ;point to selected
        LODSW                 ;operands in AX
        POP     SI            ;restore SI reg
        AND     BL,AL         ;clear AND'ed bits
        OR      BL,AH         ;set OR'ed bits
;
SATTR2: POP     CX            ;restore CX reg
        LOOP    SATTR1        ;count, until done
;
        POP     DI            ;restore DI reg
        MOV     CVATTR,BL     ;store new attr
        JMP SHO SRPRT0        ;set normal exit
;
SATTR   ENDP                  ;close procedure
;
;-----------------
;
;[x;xH, [x;xf set position
;
SSPOS   PROC    NEAR          ;open procedure
;
SSPOS0: MOV     CX,WAINDX     ;parm count in CX
        JCXZ    SRPRT0        ;no parms - exit
;
        OR      AL,AL         ;row parm = 0 ?
        JZ      SSPOS1        ;yes - skip adjust
;
        DEC     AX            ;adjust 0 to X-1
;
SSPOS1: MOV     AH,ES:AROWMX  ;max row in AH reg
        CMP     AL,AH         ;rows exceeded ?
        JA      SSPOS2        ;yes - use max row
;
        MOV     AH,AL         ;no - use row parm
;
SSPOS2: MOV     AL,DL         ;current col in AL
        DEC     CX            ;col parm exist ?
        JZ      SSPOS4        ;no - set position
;
        MOV     AL,ES:ACOLMX  ;yes - max column
        CMP     AL,[SI]       ;colmns exceeded ?
        JBE     SSPOS3        ;yes - adjust
;
        LODSB                 ;no - get col prm
        OR      AL,AL         ;column parm = 0 ?
        JZ      SSPOS4        ;yes - skip adjust
;
SSPOS3: DEC     AX            ;adjust 0 to Y-1
;
SSPOS4: XCHG    AX,DX         ;position in DX
        JMP SHO SQCLS2        ;set position/exit
;
SSPOS   ENDP                  ;close procedure
;
;-----------------
;
;[K, [0K clear to end of line
;
SCEOL   PROC    NEAR          ;open procedure
;
SCEOL0: OR      AL,AL         ;parm = 0 ?
        JNZ     SRPRT0        ;no - set nrm exit
;
SCEOL1: MOV     CX,DX         ;yes - set start
        JMP SHO SQCLS1        ;clear to line end
;
;- - - - - - - - -
;
;[2J clear screen
;
SQCLS   PROC    NEAR          ;open nested proc
;
SQCLS0: DEC     AX            ;first parameter
        DEC     AX            ; equal 2 ?
        JNZ     SRPRT0        ;no - set nrm exit
;
        XCHG    AX,CX         ;yes - zero CX reg
        MOV     DH,ES:AROWMX  ;last row in DH
;
SQCLS1: XCHG    BL,BH         ;attr in BH reg
        MOV     DL,ES:ACOLMX  ;max columns in DL
        DEC     DX            ;last culumn in DL
        MOV     AX,600h       ;init/scroll up
        INT     10h           ;BIOS video call
        XCHG    BL,BH         ;attr in BL reg
        MOV     DX,CX         ;position in DX
;
SQCLS2: MOV     AH,2          ;set crsr position
        INT     10h           ;BIOS video call
;
;- - - - - - - - -
;
;[R report position
;
SRPRT   PROC    NEAR          ;open nested proc
;
SRPRT0: POP     ES            ;restore ES reg
        MOV     AX,OFS WANRM  ;write = normal
        JMP     WANRMC        ;set write exit
;
SRPRT   ENDP                  ;close nested proc
;
;- - - - - - - - -
;
SQCLS   ENDP                  ;close nested proc
;
;- - - - - - - - -
;
SCEOL   ENDP                  ;close procedure
;
;-----------------
;
;[u restore position
;
SRSTR   PROC    NEAR          ;open procedure
;
SRSTR0:
;
        DB      0BAh          ;MOV DX,immediate
SAVPOS  DW      ?             ;saved position
;
        JMP     SQCLS2        ;set position/exit
;
SRSTR   ENDP                  ;close procedure
;
;-----------------
;
;[s save position
;
SSAVE   PROC    NEAR          ;open procedure
;
SSAVE0: MOV     SAVPOS,DX     ;store position
        JMP     SRPRT0        ;set normal exit
;
SSAVE   ENDP                  ;close procedure
;
;-----------------
;
;[xC cursor right
;
SRGHT   PROC    NEAR          ;open procedure
;
SRGHT0: ADD     DL,AL         ;adjust cur column
        MOV     AL,ES:ACOLMX  ;max column in AL
        CMP     AL,DL         ;adjst past line ?
        JA      SQCLS2        ;no - set pos/exit
;
        MOV     DL,AL         ;yes - set max col
        DEC     DX            ;adjust 0 to Y-1
        JMP     SQCLS2        ;set position/exit
;
SRGHT   ENDP                  ;close procedure
;
;-----------------
;
;[xB cursor down
;
SDOWN   PROC    NEAR          ;open procedure
;
SDOWN0: ADD     DH,AL         ;adjst current row
        MOV     AL,ES:AROWMX  ;max row in AL reg
        CMP     AL,DH         ;adjst past page ?
        JAE     SQCLS2        ;no - set pos/exit
;
        MOV     DH,AL         ;yes - set max row
        JMP     SQCLS2        ;set position/exit
;
SDOWN   ENDP                  ;close procedure
;
;-----------------
;
;[xD cursor left
;
SLEFT   PROC    NEAR          ;open procedure
;
SLEFT0: SUB     DL,AL         ;adjst past line ?
        JNC     SQCLS2        ;no - set pos/exit
;
        MOV     DL,AH         ;yes - set col 0
        JMP     SQCLS2        ;set position/exit
;
SLEFT   ENDP                  ;close procedure
;
;-----------------
;
;[xA cursor up
;
SQPUP   PROC    NEAR          ;open procedure
;
SQPUP0: SUB     DH,AL         ;adjst past page ?
        JNC     SQCLS2        ;no - set pos/exit
;
        MOV     DH,AH         ;yes - set row 0
        JMP     SQCLS2        ;set position/exit
;
SQPUP   ENDP                  ;close procedure
;
;-----------------
;
;[l set mode/enable wrap
;
SMDEW   PROC    NEAR          ;open procedure
;
SMDEW0: INC     AH            ;set wrap flag
;
;- - - - - - - - -
;
;[h set mode/disable wrap
;
SMDDW   PROC    NEAR          ;open nested proc
;
SMDDW0: CMP WPT WAINDX,0      ;any parms ?
        JZ      SRPRT0        ;no - set nrm exit
;
        CMP     AL,7          ;valid mode ?
        JAE     SMDDW1        ;check wrap flag
;
        CBW                   ;set video mode
        INT     10h           ;BIOS video call
        CALL    WINIT         ;write initialize
        JMP     SRPRT0        ;set normal exit
;
SMDDW1: JA      SRPRT0        ;set normal exit
;
        MOV     WRAPFL,AH     ;store wrap flag
        JMP     SRPRT0        ;set normal exit
;
SMDDW   ENDP                  ;close nested proc
;
;- - - - - - - - -
;
SMDEW   ENDP                  ;close procedure
;
;-----------------
;
;[n request position
;
SRQST   PROC    NEAR          ;open procedure
;
SRQST0: MOV     AL,DH         ;row in AL reg
        CALL    B2ASC         ;bin to ASCII nums
        MOV     PRRROW,AX     ;store ASCII nums
        MOV     AL,DL         ;column in AL reg
        CALL    B2ASC         ;bin to ASCII nums
        MOV     PRRCOL,AX     ;store ASCII nums
        MOV     AX,OFS PRRSTR ;string ptr in AX
        MOV     KBFPTR,AX     ;set string ptr
        MOV     AL,9          ;string cnt in AL
        MOV     KBFCNT,AL     ;set string count
        JMP     SRPRT0        ;set normal exit
;
SRQST   ENDP                  ;close procedure
;
;-----------------
;
;[p reassign key
;
SRKEY   PROC    NEAR          ;open procedure
;
SRKEY0: MOV     AX,WAINDX     ;parm count in AX
        ADD     AX,SI         ;end ptr in AX
        PUSH    DI            ;save DI register
        XCHG    AX,DI         ;end ptr in DI
        DEC     SI            ;point to 1st parm
        LODSW                 ;get first 2 parms
        MOV     BP,SI         ;source ptr in BP
        CALL    RSRCH         ;search reasgn bfr
        JC      SRKEY2        ;not found - adjst
;
        ADD     CX,SI         ;found end in CX
        DEC     SI            ;point to found
        DEC     SI            ; start in SI reg
        OR      AL,AL         ;extended char ?
        JNZ     SRKEY1        ;no - adjust index
;
        DEC     SI            ;yes - adjst start
;
SRKEY1: PUSH    CX            ;found end on stck
        SUB     CX,SI         ;mv distance in CX
        SUB     BP,CX         ;adjust source ptr
        SUB     KRINDX,CX     ;adjust index ptr
        MOV     CX,DI         ;end ptr in CX reg
        MOV     DI,SI         ;found start in DI
        POP     SI            ;found end in SI
        SUB     CX,SI         ;move count in CX
        PUSH    CS            ;loc seg on stack
        POP     ES            ;local seg in ES
        REP     MOVSB         ;move buffer end
;
SRKEY2: POP     DI            ;restore DI reg
        MOV     CX,WAINDX     ;parm count in CX
        MOV     SI,BP         ;source ptr in SI
        MOV     BP,CX         ;save count in BP
        OR      AL,AL         ;extended char ?
        JNZ     SRKEY3        ;no - test bytes
;
        DEC     CX            ;yes - adjust size
        CMP     AX,[SI]       ;words match ?
        JNZ     SRKEY5        ;not match - assgn
;
        CMP     CL,3          ;size match ?
        JMP SHO SRKEY4        ;test size match
;
SRKEY3: CMP     AL,AH         ;bytes match ?
        JNZ     SRKEY5        ;no - assign test
;
        CMP     CL,2          ;size match ?
;
SRKEY4: JZ      SRKEY6        ;yes - abort assgn
;
SRKEY5: CMP     CX,81h        ;exceeds max len ?
        JA      SRKEY6        ;yes - abort
;
        DEC     SI            ;no - strt pointer
        ADD     BP,SI         ;end pointer in BP
;
        DB      81h,0FDh      ;CMP BP,immediate
KSBUFR  DW      ?             ;sequence bfr base
;
        JA      SRKEY6        ;too long - abort
;
        MOV     KRINDX,BP     ;set new index
        MOV     [SI-2],CL     ;set count byte
;
SRKEY6: JMP     SRPRT0        ;set normal exit
;
SRKEY   ENDP                  ;close procedure
;
;-----------------
;
;convert binary byte to ASCII numbers
;
B2ASC   PROC    NEAR          ;open procedure
;
        INC     AX            ;adjust 1 to X
        CMP     AL,63h        ;3 digits ?
        JB      B2ASC0        ;no - convert
;
        MOV     AL,63h        ;yes - set 99
;
B2ASC0: AAM                   ;binary to decimal
        XCHG    AL,AH         ;low byte in AH
        OR      AX,3030h      ;set ASCII bits
        RET                   ;return to caller
;
B2ASC   ENDP                  ;close procedure
;
;-----------------
;
;reassignment search subroutine
;
RSRCH   PROC    NEAR          ;open procedure
;
        XCHG    AX,DX         ;keybrd char in DX
;
        DB      0BEh          ;MOV SI,immediate
KRBUFR  DW      ?             ;reasgn buffer ptr
;
        PUSH    AX            ;save AX register
;
RSRCH0: LODSB                 ;count byte in AL
        XOR     AH,AH         ;zero AH register
        XCHG    AX,CX         ;count in CX reg
        JCXZ    RSRCH2        ;end - flag exit
;
        DEC     CX            ;adjust count
        LODSW                 ;scan code in AX
        OR      AL,AL         ;extended char ?
        JZ      RSRCH1        ;yes - test words
;
        DEC     SI            ;no - adjust ptr
        MOV     AH,DH         ;match high bytes
;
RSRCH1: CMP     AX,DX         ;words match ?
        JZ      RSRCH3        ;yes - found exit
;
        ADD     SI,CX         ;no - point to nxt
        JMP     RSRCH0        ;until found/end
;
RSRCH2: STC                   ;not found flag
;
RSRCH3: POP     AX            ;restore AX reg
        XCHG    AX,DX         ;keybrd char in AX
        RET                   ;return to caller
;
RSRCH   ENDP                  ;close procedure
;
;-----------------
;
;reassignment index subroutine
;
RINDX   PROC    NEAR          ;open procedure
;
        ASSUME  DS:_ABSO,ES:NOTHING
;
        DB      0BEh          ;MOV SI,immediate
KRINDX  DW      ?             ;reassignmnt index
;
        DB      81h,0C6h      ;ADD SI,immed word
WAINDX  DW      0             ;write index word
;
        DB      81h,0FEh      ;CMP SI,immediate
KSEND0  DW      ?             ;buffer end offset
;
        JBE     RINDX0        ;OK - return
;
        DB      81h,0EEh      ;SUB SI,immed word
KSEND1  DW      ?             ;buffer end offset
;
        SUB     CS:WAINDX,SI  ;adjust write indx
;
        DB      0BEh          ;MOV SI,immediate
KSEND2  DW      ?             ;buffer end offset
;
RINDX0: RET                   ;return to caller
;
RINDX   ENDP                  ;close procedure
;
;-----------------
;
;write initialization subroutine
;
WINIT   PROC    NEAR          ;open procedure
;
        XOR     CX,CX         ;zero CX register
        MOV     BH,CH         ;zero BH register
        PUSH    DS            ;save DS register
        MOV     DS,CX         ;_ABSO in DS reg
        MOV     BL,AVPAGE     ;page in BL reg
        SHL     BX,1          ;word table index
        MOV     DX,APPARY[BX] ;page pos in DX
        POP     DS            ;restore DS reg
        SHR     BX,1          ;page in BL reg
        MOV     BH,BL         ;page in BH reg
;
        DB      0B3h          ;MOV BL,immediate
CVATTR  DB      7             ;current vid attr
;
        RET                   ;return to caller
;
WINIT   ENDP                  ;close procedure
;
;-----------------
;
;INT 29h handler
;
INT29   PROC    FAR           ;open procedure
;
        ASSUME  DS:NOTHING
;
        STI                   ;86 interrupts on
        PUSH    BX            ;save BX register
        PUSH    DX            ;save DX register
        PUSH    CX            ;save CX register
        CALL    WINIT         ;write initialize
        PUSH    DS            ;save DS register
        MOV     DS,CX         ;_ABSO in DS reg
        PUSH    AX            ;save AX register
        PUSH    SI            ;save SI register
        PUSH    BP            ;save BP register
        CALL WPT CS:WSTATE    ;write character
        POP     BP            ;restore BP reg
        POP     SI            ;restore SI reg
        POP     AX            ;restore AX reg
        POP     DS            ;restore DS reg
        POP     CX            ;restore CX reg
        POP     DX            ;restore DX reg
        POP     BX            ;restore BX reg
        IRET                  ;interrupt return
;
INT29   ENDP                  ;close procedure
;
;-----------------
;
;INT 1Bh handler
;
INT1B   PROC    FAR           ;open procedure
;
        MOV BPT CS:KCHBUF,3   ;store break char
        IRET                  ;interrupt return
;
INT1B   ENDP                  ;close procedure
;
;-----------------
;
;screen saver count word
;
STIMER  DW      1554h         ;current count wrd
;
;-----------------
;
;video enable/disable subroutine
;
VIDNF   PROC    NEAR          ;open procedure
;
        ASSUME  DS:_TEXT
;
        PUSH    BX            ;save BX register
        MOV     BL,36h        ;enbl/dsbl refresh
        PUSHF                 ;pseudo-INT flags
        CALL DPT INT10A       ;BIOS video call
        CLI                   ;86 interrupts off
        POP     BX            ;restore BX reg
        RET                   ;return to caller
;
VIDNF   ENDP                  ;close procedure
;
;-----------------
;
;video enable subroutine
;
VIDON   PROC    NEAR          ;open procedure
;
        PUSHF                 ;save flags
        CLI                   ;86 interrupts off
;
        DB      2Eh,0C7h,6    ;MOV WPT CS:[],imm
        DW      OFS STIMER    ;count word offset
RTIMER  DW      1554h         ;count reset value
VIDONA  DW      0C39Dh        ;POPF, RET
;
;VIDONA alternates between:
;(when not blanked)... (when blanked)
;
;POPF ;restore flags.. PUSH DS ;save DS reg
;RET. ;return to callr PUSH CS ;loc seg on stck
;
        POP     DS            ;local seg in DS
        PUSH    AX            ;save AX register
        MOV     AX,0C39Dh     ;POPF, RET in AX
        MOV     VIDONA,AX     ;set VIDON state
        MOV     AX,1200h      ;enable video
        CALL    VIDNF         ;enbl/dsbl video
        MOV     AL,9Ch        ;PUSHF in AL
        MOV     INT08A,AL     ;set INT08 state
        MOV     AX,2EFAh      ;CLI, CS: in AX
        MOV     INT08B,AX     ;set INT08 state
        MOV     AX,0EFFh      ;DEC WPT in AX
        MOV     INT08C,AX     ;set INT08 state
        POP     AX            ;restore AX reg
        POP     DS            ;restore DS reg
        POPF                  ;restore flags
        RET                   ;return to caller
;
VIDON   ENDP                  ;close procedure
;
;-----------------
;
;INT 08h handler
;
INT08   PROC    FAR           ;open procedure
;
INT08A  DB      9Ch           ;PUSHF
INT08B  DW      2EFAh         ;CLI, CS:
INT08C  DW      0EFFh         ;DEC WPT []
        DW      OFS STIMER    ;count word offset
;
;INT08A,B,C alternate between:
;(when not blanked) (when blanked)
;
;PUSHF ;save flags. JMP FPT INT08 ;execute INT 8
;CLI.. ;ints off
;DEC WPT CS:STIMER ;cnt tick
;
        JZ      INT081        ;zero - dsbl video
;
INT080: POPF                  ;true - rstr flags
;
        DB      0EAh          ;JMP FPT X:X
INT08D  DW      ?             ;INT 08 offset
INT08E  DW      ?             ;INT 08 segment
;
INT081: PUSH    DS            ;save DS reg
        PUSH    CS            ;loc seg on stack
        POP     DS            ;local seg in DS
        PUSH    AX            ;save AX register
        MOV     AL,0EAh       ;JMP FPT in AL
        MOV     INT08A,AL     ;set INT08 state
        MOV     AX,INT08D     ;INT 8 ofs in AX
        MOV     INT08B,AX     ;set INT08 state
        MOV     AX,INT08E     ;INT 8 seg in AX
        MOV     INT08C,AX     ;set INT08 state
        MOV     AX,1201h      ;disable video
        CALL    VIDNF         ;enbl/dsbl video
        MOV     AX,0E1Eh      ;PUSH DS, PUSH CS
        MOV     VIDONA,AX     ;set VIDON state
        POP     AX            ;restore AX reg
        POP     DS            ;restore DS reg
        JMP     INT080        ;execute INT 08
;
        ASSUME  DS:NOTHING
;
INT08   ENDP                  ;close procedure
;
;-----------------
;
;INT 10h handler
;
INT10   PROC    FAR           ;open procedure
;
        PUSHF                 ;save flags
        DEC     AH            ;adjust 0 to FFh
        CMP     AH,4          ;ignore function ?
        JB      INT100        ;yes - skip enable
;
        CALL    VIDON         ;test/enable video
;
INT100: INC     AH            ;adjust FFh to 0
        POPF                  ;restore flags
;
        DB      0EAh          ;JMP FPT X:X
INT10A  LABEL   DWORD         ;INT 10 vector
INT10B  LABEL   WORD          ;INT 10 offset
        DB      0Dh,'('       ;copyright chars
INT10C  LABEL   WORD          ;INT 10 segment
        DB      'C)'          ;copyright chars
;
INT10   ENDP                  ;close procedure
;
;- - - - - - - - -
;
;remainder of copyright notice
;
CRIGHT  DB      'opyright 1991, '
        DB      'David R. Sheldon',0Dh,0Ah
;
;-----------------
;
;get character (zero flag set if end of line)
;
GCHAR   PROC    NEAR          ;open procedure
;
        LODSB                 ;get next byte
        CMP     AL,0Ah        ;chr = LINE FEED ?
        JZ      GCHAR0        ;yes - exit w/zero
;
        CMP     AL,0Dh        ;char = CAR RET ?
;
GCHAR0: RET                   ;return to caller
;
GCHAR   ENDP                  ;close procedure
;
;-----------------
;
;skip characters subroutine
;
SCHAR   PROC    NEAR          ;open procedure
;
SCHAR0: CALL    GCHAR         ;get next char
        JZ      SCHAR1        ;end/line - exit
;
        CMP     AL,3Dh        ;char = EQUAL ?
        JZ      SCHAR0        ;yes - get nxt chr
;
        CMP     AL,3Ah        ;char = COLON ?
        JZ      SCHAR0        ;yes - get nxt chr
;
        CMP     AL,2Ch        ;char = COMMA ?
        JZ      SCHAR0        ;yes - get nxt chr
;
        CMP     AL,20h        ;char = SPACE ?
        JZ      SCHAR0        ;yes - get nxt chr
;
        CMP     AL,9          ;char = TAB ?
        JZ      SCHAR0        ;yes - get nxt chr
;
        OR      AL,AL         ;char = NULL ?
        JZ      SCHAR0        ;yes - get nxt chr
;
SCHAR1: LAHF                  ;no - save flags
        DEC     SI            ;point to last
        SAHF                  ;restore flags
        RET                   ;return to caller
;
SCHAR   ENDP                  ;close procedure
;
;-----------------
;
;get numeric character subroutine
;
NCHAR   PROC    NEAR          ;open procedure
;
        LODSB                 ;get next byte
        CMP     AL,30h        ;char < ASCII 0 ?
        JB      NCHAR0        ;nonnumeric - exit
;
        CMP     AL,3Ah        ;char > ASCII 9 ?
        CMC                   ;invert carry flag
        JC      NCHAR0        ;nonnumeric - exit
;
        XOR     AL,30h        ;remove ASCII bits
;
NCHAR0: RET                   ;return to caller
;
NCHAR   ENDP                  ;close procedure
;
;-----------------
;
;get 16 bit parameter subroutine
;
WPARM   PROC    NEAR          ;open procedure
;
;16 bit overflow > CF = 1, ZF = 0
;no numeric parm > CF = 0, ZF = 0
;normal numeric  > CF = 0, ZF = 1
;
        XOR     CX,CX         ;zero CX register
        MOV     DX,CX         ;zero DX register
        MOV     BX,10Ah       ;flag/multiplier
;
WPARM0: CALL    NCHAR         ;get numeric char
        JC      WPARM2        ;no numeric - exit
;
        CBW                   ;zero AH register
        MOV     BH,AH         ;clear parm flag
        XCHG    AX,CX         ;swap new w/result
        MUL     BX            ;unsigned multiply
        ADD     CX,AX         ;add to new number
        ADC     DL,DH         ;overflow ?
        JZ      WPARM0        ;no - continue
;
WPARM1: CALL    NCHAR         ;yes - get num chr
        JNC     WPARM1        ;until nonnumeric
;
WPARM2: DEC     SI            ;point to last
        SUB     BH,DL         ;set CF, ZF flags
        RET                   ;return to caller
;
WPARM   ENDP                  ;close procedure
;
;-----------------
;
;timeout parameter subroutine
;
TPARM   PROC    NEAR          ;open procedure
;
        CALL    WPARM         ;get 16 bit number
        JA      TPARM2        ;no parm - exit
;
        JC      TPARM0        ;overflw - set max
;
        CMP     CX,0E10h      ;over range ?
        JA      TPARM0        ;yes - set max val
;
        MOV     AX,0B6h       ;no - mult by 182
        MOV     BH,AH         ;zero BH register
        MUL     CX            ;unsigned multiply
        DIV     BX            ;unsign divide /10
        JMP SHO TPARM1        ;set parameter
;
TPARM0: MOV     AX,0FFFFh     ;set max timeout
;
TPARM1: MOV     CL,1          ;parm flag in CL
        TEST    CL,CS:ISFLAG  ;parm set yet ?
        JNZ     TPARM2        ;yes - exit
;
        OR      CS:ISFLAG,CL  ;no - set prm flag
        MOV     CS:STIMER,AX  ;set current count
        MOV     CS:RTIMER,AX  ;set count reset
;
TPARM2: RET                   ;return to caller
;
TPARM   ENDP                  ;close procedure
;
;-----------------
;
;sequence buffer size parameter subroutine
;
SPARM   PROC    NEAR          ;open procedure
;
        CALL    WPARM         ;get 16 bit number
        JA      SPARM2        ;no parm - exit
;
        JC      SPARM0        ;overflw - set max
;
        OR      CH,CH         ;over 8 bits ?
        JNZ     SPARM0        ;yes - set max val
;
        OR      CL,CL         ;bit 7 set ?
        JNS     SPARM1        ;no - set parmeter
;
SPARM0: MOV     CL,7Fh        ;set max buffer
;
SPARM1: MOV     AL,2          ;parm flag in AL
        TEST    AL,CS:ISFLAG  ;parm set yet ?
        JNZ     SPARM2        ;yes - exit
;
        OR      CS:ISFLAG,AL  ;no - set prm flag
        CMP     CL,8          ;val < min size ?
        JBE     SPARM2        ;yes - exit
;
        MOV     CS:ISSIZE,CL  ;no - set parmeter
;
SPARM2: RET                   ;return to caller
;
SPARM   ENDP                  ;close procedure
;
;-----------------
;
;reassignment buffer size parameter subroutine
;
RPARM   PROC    NEAR          ;open procedure
;
        CALL    WPARM         ;get 16 bit number
        JA      RPARM2        ;no parm - exit
;
        JZ      RPARM0        ;normal - set parm
;
        MOV     CX,0FFFFh     ;overflw - set max
;
RPARM0: MOV     AX,4          ;parm flag/min val
        TEST    AL,CS:ISFLAG  ;parm set yet ?
        JNZ     RPARM2        ;yes - exit
;
        CMP     AX,CX         ;val < min size ?
        JBE     RPARM1        ;no - set parm
;
        MOV     CL,AL         ;yes - set min val
;
RPARM1: OR      CS:ISFLAG,AL  ;set parm flag
        MOV     CS:IRSIZE,CX  ;set size parmeter
;
RPARM2: RET                   ;return to caller
;
RPARM   ENDP                  ;close procedure
;
;-----------------
;
;interrupt parameter(s) subroutine
;
IPARM   PROC    NEAR          ;open procedure
;
IPARM0: CALL    WPARM         ;get 16 bit number
        JNZ     IPARM1        ;over/none - skip
;
        CMP     CX,0Fh        ;val > max parm ?
        JA      IPARM1        ;yes - skip
;
        CMP     CL,2          ;val < min parm ?
        JB      IPARM1        ;yes - skip
;
        DEC     CX            ;shift count in CX
        MOV     AX,1          ;a bit in AX reg
        SHL     AX,CL         ;set bit position
        OR      CS:INFLAG,AX  ;set INT flag bit
;
IPARM1: CALL    SCHAR         ;skip characters
        JZ      IPARM2        ;end/line - exit
;
        CALL    NCHAR         ;get numeric char
        DEC     SI            ;point to number
        JNC     IPARM0        ;numeric - loop
;
IPARM2: RET                   ;return to caller
;
IPARM   ENDP                  ;close procedure
;
;-----------------
;
;revector interrupt subroutine
;
RVECT   PROC    NEAR          ;open procedure
;
        XOR     AX,AX         ;_ABSO in AX reg
        PUSH    DS            ;save DS register
        MOV     DS,AX         ;_ABSO in DS reg
        MOV     AX,CS         ;local seg in AX
        XCHG    CX,[SI]       ;swap offsets
        XCHG    AX,[SI+2]     ;swap segments
        POP     DS            ;restore DS reg
        RET                   ;return to caller
;
RVECT   ENDP                  ;close procedure
;
;-----------------
;
;initialization data area
;
ISFLAG  DB      0             ;init status flags
INFLAG  DW      0             ;INT trigger flags
IRSIZE  DW      0C8h          ;reasgn buffer sze
IWSIZE  LABEL WORD            ;seq buffer word
ISSIZE  DB      8,0           ;seq buffer byte
ICLIST  DB      'TSRItsri'    ;parm charctr list
;
ICLQTY  EQU     $-OFS ICLIST  ;parm charactr qty
;
IPPROC  DW      TPARM         ;timeout proc
        DW      SPARM         ;sequence bfr proc
        DW      RPARM         ;reassign bfr proc
IPLAST  DW      IPARM         ;INT trigger proc
;
;-----------------
;
;device driver initialization routine
;
DINIT   PROC    NEAR          ;open procedure
;
        ASSUME  DS:_TEXT
;
DINIT0: LDS     SI,ES:[DI+0Fh] ;cfg.sys srce ptr
        PUSH    BX            ;save BX register
        PUSH    ES            ;save ES register
        PUSH    CS            ;loc seg on stack
        POP     ES            ;local seg in ES
        PUSH    DI            ;save DI register
;
        ASSUME  DS:NOTHING
;
DINIT1: CALL    GCHAR         ;get next char
        JZ      DINIT5        ;end/line - deflts
;
        CMP     AL,2Fh        ;char = SLASH ?
        JZ      DINIT2        ;yes - interpret
;
        CMP     AL,2Dh        ;char = HYPHEN ?
        JZ      DINIT2        ;yes - interpret
;
        CMP     AL,2Ch        ;char = COMMA ?
        JZ      DINIT2        ;yes - interpret
;
        CMP     AL,20h        ;char > SPACE ?
        JA      DINIT1        ;yes - loop
;
DINIT2: PUSH    DX            ;save DX register
        PUSH    BP            ;save BP register
;
DINIT3: CALL    GCHAR         ;get next char
        JZ      DINIT4        ;end/line - test
;
        MOV     DI,OFS ICLIST ;parm char lst ptr
        MOV     CX,ICLQTY     ;prm qty in CX reg
        REPNZ   SCASB         ;valid parameter ?
        JNZ     DINIT3        ;no - get nxt char
;
        CALL    SCHAR         ;yes - skip chars
        JZ      DINIT4        ;end/line - test
;
        AND     CL,3          ;ignore case bit
        SHL     CX,1          ;word table index
        MOV     BX,OFS IPLAST ;last proc ptr
        SUB     BX,CX         ;point to selected
        CALL WPT CS:[BX]      ;interpret parm
        JMP     DINIT3        ;loop until done
;
DINIT4: POP     BP            ;restore BP reg
        POP     DX            ;restore DX reg
;
DINIT5: MOV     AX,1200h      ;enable refresh
        MOV     BL,36h        ;enbl/dsbl video
        INT     10h           ;BIOS video call
        MOV     DI,OFS STIMER ;default dest ptr
        PUSH    CS            ;loc seg on stack
        POP     DS            ;local seg in DS
        XOR     AL,12h        ;call supported ?
        JNZ     DINIT6        ;no - skip saver
;
        ASSUME  DS:_TEXT
;
        MOV     AH,AL         ;yes - zero AH reg
        CMP     AX,[DI]       ;nonzero timeout ?
        JNZ     DINIT7        ;yes - instl saver
;
DINIT6: PUSH    CS            ;no - loc seg/stck
        POP     ES            ;local seg in ES
        JMP     DINITD        ;instl device drvr
;
DINIT7: MOV     AH,0C0h       ;get system envirn
        INT     15h           ;BIOS I/O call
        ADC     AH,0          ;call supported ?
        JNZ     DINIT8        ;no - XT IRQs only
;
        MOV     AX,ES:[BX+2]  ;machine ID in AX
        CMP     AL,0FBh       ;ID = newer XT ?
        JZ      DINIT8        ;yes - XT IRQ only
;
        CMP     AX,2FCh       ;ID = XT-286 ?
        JZ      DINIT8        ;yes - XT IRQ only
;
        MOV     AL,40h        ;slave PIC cfg flg
        TEST    AL,ES:[BX+5]  ;slave PIC exist ?
        JZ      DINIT8        ;no - XT IRQs only
;
        MOV     AX,INFLAG     ;AT flgs in AX reg
        MOV     BX,AX         ; and in BX also
        AND     BL,0FCh       ;clr unused bits
        SHR     AL,1          ;IRQ 2 to bit 0
        AND     AL,1          ;bit 0 only
        OR      BH,AL         ;set into IRQ 9 
        JMP SHO DINIT9        ;generate handlers
;
DINIT8: MOV     BX,INFLAG     ;XT flgs in BX reg
        AND     BX,7Eh        ;clr unused bits
;
DINIT9: INC     BX            ;always use IRQ 1
        MOV     DI,OFS CRIGHT ;dest ptr in DI
        MOV     SI,OFS AINT09 ;vector ptr in SI
        PUSH    CS            ;loc seg on stack
        POP     ES            ;local seg in ES
        PUSHF                 ;save flags
        CLI                   ;86 interrupts off
;
DINITA: SHR     BX,1          ;IRQ bit to carry
        JA      DINITB        ;false/nonzero
;
        JNC     DINITC        ;false/zero - done
;
        MOV     CX,DI         ;hndlr ofset in DI
        CALL    RVECT         ;revector interupt
        PUSH    AX            ;save old segment
        MOV     AL,0E8h       ;near CALL instrct
        STOSB                 ;store instruction
        MOV     AX,OFS VIDON-2 ;subrtn ofs in AX
        SUB     AX,DI         ;displacemnt in AX
        STOSW                 ;store displacemnt
        MOV     AL,0EAh       ;far JMP instructn
        STOSB                 ;store instruction
        XCHG    AX,CX         ;old offset in AX
        STOSW                 ;store old offset
        POP     AX            ;recall old segmnt
        STOSW                 ;store old segment
;
DINITB: ADD     SI,4          ;point to nxt vect
        CMP     SI,40h        ;INT 10 vector ?
        JNZ     DINITA        ;no - loop
;
        MOV     SI,OFS AINT70 ;yes - IRQ 8 vect
        JMP     DINITA        ;loop until done
;
DINITC: MOV     SI,OFS AINT08 ;INT 8 vector ptr
        MOV     CX,OFS INT08  ;INT 8 hndlr ofst
        CALL    RVECT         ;revector interupt
        MOV     INT08E,AX     ;store old segment
        XCHG    AX,CX         ;old offset in AX
        MOV     INT08D,AX     ;store old offset
        MOV     SI,OFS AINT10 ;INT 10 vector ptr
        MOV     CX,OFS INT10  ;INT 10 hndlr ofst
        CALL    RVECT         ;revector interupt
        MOV     INT10C,AX     ;store old segment
        XCHG    AX,CX         ;old offset in AX
        MOV     INT10B,AX     ;store old offset
        POPF                  ;restore flags
;
DINITD: MOV     KRBUFR,DI     ;store reasgn ptr
        MOV     AX,2          ;1st 2 PRTSC bytes
        STOSW                 ;store 1st 2 bytes
        MOV     AX,1072h      ;2nd 2 PRTSC bytes
        STOSW                 ;store 2nd 2 bytes
        XOR     AX,AX         ;zero AX register
        STOSB                 ;store null byte
        XCHG    AX,BX         ;zero BX register
        XCHG    AX,DI         ;current ptr in AX
        POP     DI            ;restore DI reg
        POP     ES            ;restore ES reg
        MOV     KRINDX,AX     ;store reasgn indx
        ADD     AX,0Ch        ;adj to paragraph
        ADD     AX,IWSIZE     ;+ seq buffer size
        ADD     AX,IRSIZE     ;+ reasgn bfr size
        JNC     DINITE        ;no overflow - OK
;
        XCHG    AX,BX         ;overflw - zero AX
;
DINITE: RCR     AX,1          ;recover bit 16
        AND     AL,0F8h       ;paragraph justify
        MOV     BX,AX         ;save para in BX
        DEC     AX            ;X-2 = tail ptr
        SHL     AX,1          ;recover bit 0
        MOV     KSEND0,AX     ;store tail ptr 0
        MOV     KSEND1,AX     ;store tail ptr 1
        MOV     KSEND2,AX     ;store tail ptr 2
        SUB     AX,IWSIZE     ;seq bfr base ptr
        INC     AX            ;adjust for tail
        MOV     KSBUFR,AX     ;store seq bse ptr
        MOV     SI,OFS AINT1B ;INT 1B vector ptr
        MOV     CX,OFS INT1B  ;INT 1B hndlr ofst
        PUSHF                 ;save flags
        CLI                   ;86 interrupts off
        CALL    RVECT         ;revector interupt
        MOV     SI,OFS AINT29 ;INT 29 vector ptr
        MOV     CX,OFS INT29  ;INT 29 hndlr ofst
        CALL    RVECT         ;revector interupt
        POPF                  ;restore flags
        MOV     CL,3          ;paragraphs/segmnt
        SHR     BX,CL         ;segment qty in BX
        MOV     AX,CS         ;local seg in AX
        ADD     AX,BX         ;break segment
        POP     BX            ;restore BX reg
        MOV     ES:[DI+0Dh],AX ;store break seg
        XOR     AX,AX         ;zero AX reg
        MOV     ES:[DI+0Bh],AX ;store break ofst
        MOV     AX,OFS INTRP2 ;done ofst in AX
        MOV     DSPTCH,AX     ;replace init ofst
        JMP     AX            ;done status exit
;
DINIT   ENDP                  ;close procedure
;
;-----------------------------------------------
;
_TEXT   ENDS                  ;clse code segment
;
;-----------------------------------------------
;
        END                   ;entry is header
;
